
Supplementary Materials for 'A Comprehensive and Reproducible Comparison 
of Clustering and Optimization Rules in Wi-Fi Fingerprinting'
https://zenodo.org/record/3968503

This package includes the materials and methods to reproduce the results
presented in the paper detailed below. If you would like to re-use the software
provided and/or the empirical evaluation please cite the two following items. 

	Torres-Sospedra, J.; Richter, P.; Moreira, A.; Mendoza-Silva, G.; Lohan, E.;
	Trilles, S.; Matey-Sanz, M. and Huerta, J. A Comprehensive and Reproducible 
	Comparison of Clustering and Optimization Rules in Wi-Fi Fingerprinting 
	IEEE Transactions on Mobile Computing, 2020
	https://doi.org/10.1109/TMC.2020.3017176

	Torres-Sospedra, J.; Richter, P.; Moreira, A.; Mendoza-Silva, G.; Lohan, E.;
	Trilles, S.; Matey-Sanz, M. and Huerta, J. "Supplementary Materials for
	'A Comprehensive and Reproducible Comparison of Clustering and Optimization 
	Rules in Wi-Fi Fingerprinting'", v1.0, Zenodo, 2020.  
	[Available Online] https://zenodo.org/record/3968503

If you would like to re-use the databases included in this paper, please cite
the corresponding sources as indicated in the readme file in the folder
'databases'.

If you want to re-run the experiments in your computer, please execute the
script executeAll (provided for MatLab/Octave and linux shell). Scripts have been
tested with Octave 5.2.

If you have any questions about this package, please do not hesitate to contact
J. Torres-Sospedra (jtorres@uji.es -- info@jtorr.es -- jtorres.phd@gmail.com).

--------------------------------------------------------------------------------
Contents of the package
--------------------------------------------------------------------------------
Main folders

	Zenodo_3968503\ -- Folder that includes the functions and scripts to reproduce
	the work done in the TMC paper

	Zenodo_3968503\databases -- Folder with the databases in .mat format (see
	readme.md on folder for additional information)

	Zenodo_3968503\Clusters -- Folder where the clusters are stored after
	executing a method on a dataset (please execute executeAll script) 
	
	Zenodo_3968503\Results -- Folder where the full results are  stored after
	executing a method on a dataset (please execute executeAll script) 
	
	Zenodo_3968503\Results_CSV_paper -- Folder where the results reported in the paper
	are summarized (normalized error, normalized time, full error, full time)


Plain Fingerprint-based KNN Method

	Zenodo_3968503\knn_plain.m -- Fingerprint method based on KNN. Requires the 
	files below to work. Requires the database and execution parameters (provided
	by RunMethod)

	Zenodo_3968503\datarepExponential.m -- Converts RSSI to Exponential
	Representation 

	Zenodo_3968503\datarepPositive.m -- Converts RSSI to Positive Representation 

	Zenodo_3968503\datarepPowed.m -- Converts RSSI to Powed Representation

	Zenodo_3968503\datarepNewNull.m -- Replaces NaN Values (+100 in our datastes)
	to a new valid default value 

	Zenodo_3968503\datarepNewNullDB.m -- Replaces NaN Values (+100 in our datastes)
	to a new valid default value 

	*** Set of measures to compute the distance/similarity between fingerprints
	Zenodo_3968503\distance_cityblock.m  
	Zenodo_3968503\distance_LGD.m
	Zenodo_3968503\distance_PLGD10.m 
	Zenodo_3968503\distance_PLGD40.m
	Zenodo_3968503\distance_euclidean.m  
	Zenodo_3968503\distance_sorensen.m
	Zenodo_3968503\distance_hamming.m  
	Zenodo_3968503\distance_neyman.m
	Zenodo_3968503\distance_squaredeuclidean.m

	*** Compute the execution time  
	Zenodo_3968503\myTic.m 
	Zenodo_3968503\myToc.m

	*** Remaps the buildingID and Floor ID to range 1...n
	Zenodo_3968503\remapBldDB.m 
	Zenodo_3968503\remapFloorDB.m
	Zenodo_3968503\remapVector.m

Improved Fingerprint-based KNN with optimization rules and clustering

	Zenodo_3968503\knn_affinitypropagationSparse.m
	Zenodo_3968503\knn_affinitypropagationSparseAltSim.m
	Zenodo_3968503\knn_fengyou.m
	Zenodo_3968503\	Zenodo_3968503\knn_fengyou025Optimized.m
	Zenodo_3968503\knn_fengyou050Optimized.m
	Zenodo_3968503\knn_fengyou075Optimized.m
	Zenodo_3968503\knn_fengyouOptimized.m
	Zenodo_3968503\knn_grid.m
	Zenodo_3968503\knn_kmeansAltParams.m
	Zenodo_3968503\knn_kmeansTradParams.m
	Zenodo_3968503\knn_kushki.m
	Zenodo_3968503\knn_marques10db.m
	Zenodo_3968503\knn_moreira1.m
	Zenodo_3968503\knn_moreira3.m
	Zenodo_3968503\knn_moreiraSimilar12dbm.m
	Zenodo_3968503\knn_moreiraSimilar6dbm.m
	Zenodo_3968503\knn_overlappinggrid.m
	Zenodo_3968503\knn_percentilerule25.m
	Zenodo_3968503\knn_percentilerule50.m
	Zenodo_3968503\knn_percentilerule75.m

Run Methods

	Zenodo_3968503\runMethod.m -- Function to execute a KNN base method on a
	dataset with the appropriate parameters

	Zenodo_3968503\loadDatabase.m -- Loads the database structure with the training
	and testing data (including labels)

	Zenodo_3968503\mkSubdirs.m -- Generates subdirs if necessary

Scripts to run all the combinations

	Zenodo_3968503\generateScripts.m -- Generates the scripts to execute all
	combinations (see files below)

	Zenodo_3968503\executeAll.m -- Executes all the combinations tested in the
	paper (Matlab/Octave script)

	Zenodo_3968503\executeAll.sh -- Executes octave with the combinations tested in	the paper (shell script)

	Zenodo_3968503\getOptimalParams.m -- Given a datasets and a case, Simple 1-NN
	(2) or Best Params (3), returns the corresponding distance metrics, value of k
	and data represention

	Zenodo_3968503\getFeaturesDB.m -- Provides some base features of the dataset as	number of samples

Scripts to run a sample set

	Zenodo_3968503\generateScriptsSample.m -- Generates the scripts to execute just
	a method based on each of the three variants (with k-means)

	Zenodo_3968503\executeSample.m -- Executes the sample set 
	Results folder)

	Zenodo_3968503\executeSample.sh -- Executes the sample set (shell script)

--------------------------------------------------------------------------------
--------------------------------------------------------------------------------

This package includes the function kmeans_local.m which was originally
included in Octave 5.1.0 Statistical Package as kmeans.m. It was developed by 
Soren Hauberg <soren@hauberg.org> (2011), Daniel Ward <dwa012@gmail.com> (2012) 
and Lachlan Andrew <lachlanbis@gmail.com> (2015-2016); and released under GNU
General Public License.

This package includes the function apclusterSparseOriginal.m which was originally
included in the Affinity Propagation Package as apclusterSparse.m. It was developed by 
Brendan J. Frey and Delbert Dueck (2006).
