function  runMethod (databaseName,datarep,clustering,distanceMetric,k,repetitions,k2,labelk2)
  
  
  if exist('OCTAVE_VERSION', 'builtin') ~= 0;
    saveOption = '-mat7-binary';
  else
    saveOption = '-mat';
  end

  
  sep = filesep();
  
  database = loadDatabase('databases',databaseName);
  defaultNonDetectedValue = 100; 
  newNonDetectedValue     = min([database.trainingMacs(:);database.testMacs(:)]) - 1;
  
 		
  for i = repetitions
    
    fprintf('%s -- %s repetition %d of %d',clustering,databaseName,i,repetitions(end));
    
    if  strcmp(clustering,'knn_plain') ...
        || strcmp(clustering,'knn_fengyou') ...
        || strcmp(clustering,'knn_fengyouOptimized') ...
        || strcmp(clustering,'knn_fengyou025Optimized') ...
        || strcmp(clustering,'knn_fengyou050Optimized') ...
        || strcmp(clustering,'knn_fengyou075Optimized') ...
        || strcmp(clustering,'knn_marques10db') ...
        || strcmp(clustering,'knn_moreira1') ...
        || strcmp(clustering,'knn_moreira3') ...
        || strcmp(clustering,'knn_moreiraSimilar12dbm') ...
        || strcmp(clustering,'knn_moreiraSimilar6dbm') ...
        || strcmp(clustering,'knn_percentilerule25') ...
        || strcmp(clustering,'knn_percentilerule50') ...
        || strcmp(clustering,'knn_percentilerule75')

      % knn method with RSSI based rules 
        
      results  = feval(clustering, database , k, datarep, ...
              defaultNonDetectedValue, newNonDetectedValue , ...
              distanceMetric );  
        
      folderResults = ['Results' sep databaseName sep clustering sep  datarep '_' strrep(distanceMetric,'distance_','') '_k' sprintf('%03d',k)] ;
      
      saveClusters = 0; % Clusters are saved

    elseif   size(strfind(clustering,'knn_kmeans'),1) ... 
              || size(strfind(clustering,'knn_grid'),1) ...
              || size(strfind(clustering,'knn_overlappinggrid'),1)
		
      % knn with clustering (2-step search) - k-means (it requires to set the number of clusters)       
      [results,clusters]  = feval(clustering, database , k, datarep, ...
                    defaultNonDetectedValue, newNonDetectedValue , ...
                    distanceMetric, k2 , i);  
      folderResults = ['Results' sep databaseName sep clustering '_k' labelk2 sep datarep '_' strrep(distanceMetric,'distance_','') '_k' sprintf('%03d',k)] ;
      
      saveClusters = 1; % Clusters are saved
	
	  elseif strcmp(clustering,'knn_affinitypropagationSparse') ...
			    || strcmp(clustering,'knn_affinitypropagationSparseAltSim')
	
      folderAP = ['Clusters/' databaseName '/' clustering  '/'] ;
      if ~exist(folderAP)
        mkSubdirs(folderAP);
      end
      [results,clusters]  = feval(clustering, database , k, datarep, ...
                  defaultNonDetectedValue, newNonDetectedValue , ...
                  distanceMetric, folderAP );    

      folderResults = ['Results' sep databaseName sep clustering sep datarep '_' strrep(distanceMetric,'distance_','') '_k' sprintf('%03d',k)] ;
      
      saveClusters = 0; % Clusters are calculated once and sotred in an independent folder
   
	  elseif strcmp(clustering,'knn_kushki') 
	
      folderKuskhi = ['Clusters/' databaseName '/knn_kushki_surveypoints/'] ;
      if ~exist(folderKuskhi)
        mkSubdirs(folderKuskhi);
      end
      [results,clusters]  = feval(clustering, database , k, datarep, ...
                  defaultNonDetectedValue, newNonDetectedValue , ...
                  distanceMetric, k2, folderKuskhi );                 

      folderResults = ['Results' sep databaseName sep clustering '_' labelk2 sep datarep '_' strrep(distanceMetric,'distance_','') '_k' sprintf('%03d',k)] ;
      
      saveClusters = 0; % Clusters are calculated once and sotred in an independent folder
      
    end
    
    
    if ~exist(folderResults)
      mkSubdirs(folderResults);
    end
    save([folderResults sep 'results_rep' sprintf('%03d',i) '.mat' ],'results',saveOption)
	
    if saveClusters

      folderClusters = ['Clusters/' databaseName '/' clustering  '/'] ;
      if ~exist(folderClusters)
        mkSubdirs(folderClusters);
      end
      save([folderClusters 'clusters_' datarep '_' labelk2 '_' sprintf('%03d',i) '.mat' ],'clusters',saveOption);

    end
   
  end
  
end
  
